routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes();

Route::get('/jenis', 'HomeController@jenis')->name('jenis');

Route::name('Auth.')->namespace('Auth')->prefix('auth')->group(function () {

	Route::name('Admin.')->prefix('admin')->group(function () {
		Route::post('store', 'AdminsController@store')->name('store');
	});
	
	Route::post('adminLogin', 'LoginController@adminLogin')->name('adminLogin');

});

Route::group(['middleware' => 'auth:admin'], function () {

	Route::name('Admin.')->namespace('Admin')->prefix('admin')->group(function () {

		Route::name('Dashboard.')->namespace('Dashboard')->prefix('dashboard')->group(function () {
			Route::get('/', 'DashboardController@index')->name('index');
		});

		Route::name('Master.')->namespace('Master')->prefix('master')->group(function () {

			#Jenis
			Route::name('Jenis.')->namespace('Jenis')->prefix('jenis')->group(function () {
				Route::get('/', 'JenisController@index')->name('index');
				Route::get('/getdata', 'JenisController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'JenisController@edit')->name('edit');
				Route::post('store', 'JenisController@store')->name('store');
				Route::post('destroy', 'JenisController@destroy')->name('destroy');
			});

			#Grade
			Route::name('Grade.')->namespace('Grade')->prefix('grade')->group(function () {
				Route::get('/', 'GradeController@index')->name('index');
				Route::get('/getdata', 'GradeController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'GradeController@edit')->name('edit');
				Route::post('store', 'GradeController@store')->name('store');
				Route::post('destroy', 'GradeController@destroy')->name('destroy');
			});

			#Pengguna
			Route::name('Pengguna.')->namespace('Pengguna')->prefix('pengguna')->group(function () {
				Route::get('/', 'PenggunaController@index')->name('index');
				Route::get('/getdata', 'PenggunaController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'PenggunaController@edit')->name('edit');
				Route::get('/show/{id}', 'PenggunaController@show')->name('show');
				Route::post('store', 'PenggunaController@store')->name('store');
				Route::post('destroy', 'PenggunaController@destroy')->name('destroy');
			});

			#Bank
			Route::name('Bank.')->namespace('Bank')->prefix('bank')->group(function () {
				Route::get('/', 'BankController@index')->name('index');
				Route::get('/getdata', 'BankController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'BankController@edit')->name('edit');
				Route::post('store', 'BankController@store')->name('store');
			});

		});

		Route::name('Katalog.')->namespace('Katalog')->prefix('katalog')->group(function () {

			#
			Route::name('Produk.')->namespace('Produk')->prefix('produk')->group(function () {
				Route::get('/data/{id}', 'ProdukController@index')->name('index');
				Route::get('/getdata/{id}', 'ProdukController@getdata')->name('getdata');
				Route::get('/edit/{id}', 'ProdukController@edit')->name('edit');
				Route::post('store', 'ProdukController@store')->name('store');
				Route::post('destroy', 'ProdukController@destroy')->name('destroy');
			});

		});

		#Jenis
		Route::name('Transaksi.')->namespace('Transaksi')->prefix('transaksi')->group(function () {
			Route::get('/', 'TransaksiController@index')->name('index');
			Route::get('/getdata', 'TransaksiController@getdata')->name('getdata');
			Route::get('/edit/{id}', 'TransaksiController@edit')->name('edit');
			Route::post('store', 'TransaksiController@store')->name('store');
		});

	});

});

app/Models/Katalog/Produk.php
<?php

namespace App\Models\Katalog;

use Illuminate\Database\Eloquent\Model;
use Eloquent;

class Produk extends Model
{
    protected $table = 'produk';

    protected $fillable = [
        'foto','video','nama','deskripsi','harga','grade_id','jenis_id'
    ];

    public function grade(){
    	return $this->belongsTo('App\Models\Master\Grade','grade_id','id');
    }

    public function jenis(){
    	return $this->belongsTo('App\Models\Master\Jenis','jenis_id','id');
    }
}

app/Http/Controllers/Admin/Katalog/Produk/ProdukController.php
<?php

namespace App\Http\Controllers\Admin\Katalog\Produk;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Master\Grade;
use App\Models\Master\Jenis;
use App\Models\Katalog\Produk;
use Validator;
use DataTables;
use File;

class ProdukController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($id)
    {
        $grade = Grade::where('jenis_id',$id)->get();
        $jenis = Jenis::find($id);

        return view('admin.katalog.produk.index', compact(['grade','jenis']));
    }

    public function getdata($id)
    {
        $data = Produk::with('grade')->where('jenis_id',$id)->get();
        return DataTables::of($data)
            ->addIndexColumn()
            ->addColumn('action', function ($row) {
                $btn = '<button type="button" class="btn btn-warning btn-sm Edit" data-id="' . $row->id . '">
                            <i class="material-icons">mode_edit_outline</i>
                        </button>
                        <button type="button" class="btn btn-sm  btn-danger Delete" data-id="' . $row->id . '">
                            <i class="material-icons">restore_from_trash</i>
                        </button>
                        ';
                return $btn;
            })
            ->addColumn('grade', function ($row) {
                return $row->grade->nama_grade;
            })
            ->addColumn('harga', function ($row) {
                return number_format($row->harga,0,'.','.');
            })
            ->addColumn('foto', function ($row) {
                $foto = '<img src="'.asset("uploads/foto/produk/".$row->foto."").'" class="img-fluid" width="100%">';
                return $foto;
            })
             ->addColumn('video', function ($row) {
                if($row->video == ''){
                    $video = '';
                }else{
                    $video = '<video width="100%" controls><source src="'.asset("uploads/video/produk/".$row->video."").'" type="video/mp4"></video>';   
                }
                
                return $video;
            })
            ->rawColumns(['action','grade','harga','foto','video'])
            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'nama' => 'required',
            'foto' => 'nullable|image|mimes:jpeg,png,jpg,gif|max:2048',
            'video' => 'nullable|file|mimetypes:video/mp4',
        ]);

        if ($validator->fails()) {
            $output = array(
                'state' => '500',
                'msg' => $validator->errors()->first(),
            );
        }else{

            $data = array(
                'nama' => $request->nama,
                'deskripsi' => $request->deskripsi,
                'harga' => str_replace('.','',$request->harga),
                'grade_id' => $request->grade_id,
                'jenis_id' => $request->jenis_id
            );

            if ($request->file('foto') != null) {

                if($request->id != ''){
                    $getdata = Produk::find($request->id);
                    if($getdata->foto != ""){
                        File::delete(public_path("uploads/foto/produk/".$getdata->foto));
                    }
                }

                $foto = date('ymdhis').'-'.str_replace(" ","_", $request->file('foto')->getClientOriginalName());
                $request->file('foto')->move(public_path('uploads/foto/produk'), $foto);
                $data['foto'] = $foto;
            }


            if ($request->file('video') != null) {

                if($request->id != ''){
                    $getdata = Produk::find($request->id);
                    if($getdata->video != ""){
                        File::delete(public_path("uploads/video/produk/".$getdata->video));
                    }
                }

                $video = date('ymdhis').'-'.str_replace(" ","_", $request->file('video')->getClientOriginalName());
                $request->file('video')->move(public_path('uploads/video/produk'), $video);
                $data['video'] = $video;
            }

            $insert = Produk::updateOrCreate(
                [
                    'id' => $request->id
                ],
                $data
            );

            if($insert){
                $output = array(
                    'state' => 200,
                    'msg' => 'Sukses'
                );
            }else{
                $output = array(
                    'state' => 500,
                    'msg' => 'Gagal'
                );
            }

        }

        /*$output = array(
            'state' => '500',
            'msg' => $request->file('foto')->getClientOriginalName()
        );*/

        echo json_encode($output);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data = Produk::find($id);
        return response()->json($data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {
        $data = Produk::find($request->id);

        File::delete(public_path("uploads/foto/produk/".$data->foto));
        File::delete(public_path("uploads/video/produk/".$data->video));

        $delete = Produk::find($request->id)->delete();

        if($delete)
        {
            $output = array(
                'state' => 200,
                'msg' => 'Sukses'
            );

        }else{
            $output = array(
                'state' => 500,
                'msg' => 'Gagal'
            );
        }

        echo json_encode($output);
    }
}

app/Http/Controllers/Api/Katalog/ProdukController.php
<?php

namespace App\Http\Controllers\Api\Katalog;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use JWTAuth;
use App\Models\Katalog\Produk;
use Tymon\JWTAuth\Exceptions\JWTException;
use Symfony\Component\HttpFoundation\Response;
use Illuminate\Support\Facades\Validator;

class ProdukController extends Controller
{
    protected $user;
 
    public function getdata(Request $request)
    {
        $jenis_id = $request->input('jenis_id');
        $nama = $request->input('nama');

        try {

            if ($user = JWTAuth::parseToken()->authenticate()) {

                if(empty($nama)){
                    $list = Produk::with('grade')->where('jenis_id',$jenis_id)->orderby('nama','asc')->paginate(6);
                }else{
                    $list = Produk::with('grade')->where('jenis_id',$jenis_id)->where('nama','LIKE','%'.$nama.'%')->orderby('nama','asc')->paginate(6);
                }

                return response()->json([
                    'success' => true,
                    'message' => 'Success',
                    'data' => $list
                ], Response::HTTP_OK);
            }

        } catch (Tymon\JWTAuth\Exceptions\TokenExpiredException $e) {

            return response()->json(['failed'], $e->getStatusCode());

        }
    }


}

resources/views/admin/katalog/produk/index.blade.php
@extends('welcome')

@section('content')

	<div class="row">
        <div class="col">
            <div class="page-description d-flex align-items-center">
                <div class="page-description-content flex-grow-1">
                    <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item">Katalog</li>
                        <li class="breadcrumb-item" aria-current="page">Produk {{ $jenis->nama_jenis }}</li>
                    </ol>
                </nav>
                </div>
                <div class="page-description-actions">
                    <a href="javascript:void(0)" class="btn btn-primary" id="Add"><i class="material-icons">add</i>Produk {{ $jenis->nama_jenis }}</a>
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col">
            <div class="card">
                <div class="card-body">
                    <table id="tbldata" class="display" style="width:100%">
                        <thead>
                            <tr>
                                <th width="5%">No</th>
                                <th width="15%">Nama</th>
                                <th width="10%">Grade</th>
                                <th width="10%">Harga</th>
                                <th width="15%">Foto</th>
                                <th width="15%">Video</th>
                                <th width="20%">Deskripsi</th>
                                <th width="10%">Aksi</th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

    <!-- Begin::Form Input -->
    <div class="modal fade" id="ModalAdd" tabindex="-1" aria-labelledby="exampleModalCenterTitle" style="display: none; margin-top: 100px;" aria-hidden="true">
        <div class="modal-dialog modal-lg modal-dialog-scrollable">
            <div class="modal-content">
                <div class="modal-header">
                    <div class="col-lg-9"><h5 class="modal-title" id="ModalTitle"></h5></div>
                    <div class="col-lg-3">
                        <button type="button" class="btn btn-primary" id="simpan">Simpan</button>
                        <button type="button" class="btn btn-secondary" id="close" data-bs-dismiss="modal">Tutup</button>
                    </div>
                </div>
                <div class="modal-body">
                    <form class="row g-3" id="forms">
                        <input type="hidden" id="id">
                        <input type="hidden" id="jenis_id" value="{{ $jenis->id }}">

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Nama</label>
                            <input type="text" class="form-control" id="nama">
                        </div>

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Harga</label>
                            <input type="text" class="form-control" id="harga">
                        </div>

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Deskripsi</label>
                            <textarea class="form-control" id="deskripsi"></textarea>
                        </div>

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Grade</label>
                            <select class="form-select" id="grade_id">
                                @foreach($grade as $item)
                                    <option value="{{ $item->id }}">{{ $item->nama_grade }}</option>
                                @endforeach
                            </select>
                        </div>

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Foto</label>
                            <input type="file" class="form-control" id="foto">
                        </div>

                        <div class="col-12">
                            <label for="inputAddress" class="form-label">Video</label>
                            <input type="file" class="form-control" id="video">
                        </div>
                        
                    </form>
                </div>
                <div class="modal-footer">
                    &nbsp;
                </div>
            </div>
        </div>
    </div>
    <!-- End::From Input -->

    <script>

        var table = null;
        table = $('#tbldata').DataTable({
            responsive: true,
            searchDelay: 500,
            processing: true,
            serverSide: true,
            dom: "<'row'<'col-sm-12 col-md-5'l><'col-sm-12 col-md-7 dataTables_pager'f>>rt<'row'<'col-sm-12 col-md-5'i><'col-sm-12 col-md-7 dataTables_pager'p>>",
            lengthMenu: [5, 10, 25, 50],
            pageLength: 10,
            language: {
                'lengthMenu': 'Tampilkan _MENU_',
            },
            order: [[0, 'asc']],
            ajax: "{{ url('admin/katalog/produk/getdata') }}" +"/{{ $jenis->id }}",
            columns: [
                {data: 'DT_RowIndex'},
                {data: 'nama'},
                {data: 'grade'},
                {data: 'harga'},
                {data: 'foto'},
                {data: 'video'},
                {data: 'deskripsi'},
                {data: 'action'}
            ]
            
        });

        $('body').on('click', '#Add', function (e) {
            $('#ModalAdd').modal('show');
            $('#ModalTitle').html('Add');
            $('#forms').trigger("reset");
            $('#id').val('');
        });

        $('body').on('click', '.Edit', function (e) {
            $('#forms').trigger("reset");
            $('#id').val('');
            var id = $(this).data('id');
            $.get("{{ url('admin/katalog/produk/edit')}}" +"/"+ id,function(data){

                $('#ModalAdd').modal('show');

                $('#id').val(data.id);
                $('#nama').val(data.nama);
                $('#harga').val(data.harga);
                $('#deskripsi').val(data.deskripsi);
                $('#grade_id').val(data.grade_id);

            });
        });

        $('body').on('click', '#simpan', function (e) {
            var fd;
            fd = new FormData();
            fd.append('id', $('#id').val());
            fd.append('nama', $('#nama').val());
            fd.append('harga', $('#harga').val());
            fd.append('deskripsi', $('#deskripsi').val());
            fd.append('grade_id', $('#grade_id').val());
            fd.append('jenis_id', $('#jenis_id').val());

            if($('#foto').get(0).files.length > 0){
                fd.append('foto', $('#foto').prop('files')[0]);
            }else{
                fd.append('foto', '');
            }

            if($('#video').get(0).files.length > 0){
                fd.append('video', $('#video').prop('files')[0]);
            }else{
                fd.append('video', '');
            }

            fd.append('_token', '{{ csrf_token() }}');

            $.ajax({
                data: fd,
                url: "{{ route('Admin.Katalog.Produk.store') }}",
                type: "POST",
                dataType: 'json',
                processData: false,
                contentType: false,
                beforeSend: function() {
                    $('#simpan').html('<span class="spinner-grow spinner-grow-sm" role="status"></span> Loading...');
                    $('#simpan').prop("disabled",true);
                    $('#close').prop("disabled",true);
                },
                success: function (data) {

                    if(data.state == '200'){
                        Swal.fire(data.msg, "", "success");
                        $('#ModalAdd').modal('hide');
                    }else{
                        Swal.fire(data.msg, "", "error");
                    }
                    table.draw();

                },
                error: function (data) {
                    $('#simpan').html('<i class="icon-sm fas fa-save"></i> Simpan');
                    $('#simpan').prop("disabled",false);
                    $('#close').prop("disabled",false);
                    console.log(data);
                },
                complete: function() {
                    $('#simpan').html('<i class="icon-sm fas fa-save"></i> Simpan');
                    $('#simpan').prop("disabled",false);
                    $('#close').prop("disabled",false);
                }
            });

        });

        $('body').on('click', '.Delete', function (e) {
            var id = $(this).data('id');
            Swal.fire({
                title: "Anda yakin ?",
                icon: "question",
                showCancelButton: true,
            }).then(function(result) {
                if (result.value) {
                    var fd;
                    fd = new FormData();
                    fd.append('id', id);
                    fd.append('_token', '{{ csrf_token() }}');

                    $.ajax({
                        data: fd,
                        url: "{{ route('Admin.Katalog.Produk.destroy') }}",
                        type: "POST",
                        dataType: 'json',
                        processData: false,
                        contentType: false,
                        success: function (data) {

                            if(data.state == '200'){
                                Swal.fire(data.msg, "", "success");
                            }else{
                                Swal.fire(data.msg, "", "error");
                            }
                            table.draw();

                        },
                        error: function (data) {
                            console.log(data);
                        },
                        complete: function() {
                        }
                    });
                }
            });
        });


        
    </script>

@endsection